import { Subject } from 'rxjs';
import { Format } from './wrapper';
export interface PowerShellStreams {
    success: Array<any>;
    error: Array<any>;
    warning: Array<any>;
    verbose: Array<any>;
    debug: Array<any>;
    info: Array<any>;
}
declare class SubjectWithPromise<T> extends Subject<T> {
    promise(): Promise<T>;
}
export declare class PowerShell {
    success$: Subject<any[]>;
    error$: Subject<any[]>;
    warning$: Subject<any[]>;
    verbose$: Subject<any[]>;
    debug$: Subject<any[]>;
    info$: Subject<any[]>;
    private powershell;
    private stdin;
    private stdout;
    private stderr;
    private read_out;
    private read_err;
    private delimit_head;
    private delimit_tail;
    private queue;
    private ready$;
    private queued$;
    constructor();
    private initPowerShell;
    private initReaders;
    private initQueue;
    private _call;
    call(command: string, format?: Format): SubjectWithPromise<PowerShellStreams>;
    destroy(): boolean;
}
export {};
