"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PowerShell = void 0;
var child_process_1 = require("child_process");
var os_1 = __importDefault(require("os"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var stream_1 = require("stream");
var wrapper_1 = require("./wrapper");
var debug_1 = require("debug");
var log = {
    info: debug_1.debug('fps:info'),
    error: debug_1.debug('fps:error')
};
function parseStream(stream, format) {
    if (format != null) {
        return JSON.parse(stream);
    }
    else {
        return stream;
    }
}
var SubjectWithPromise = /** @class */ (function (_super) {
    __extends(SubjectWithPromise, _super);
    function SubjectWithPromise() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SubjectWithPromise.prototype.promise = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, rxjs_1.firstValueFrom(this)];
            });
        });
    };
    return SubjectWithPromise;
}(rxjs_1.Subject));
var BufferReader = /** @class */ (function (_super) {
    __extends(BufferReader, _super);
    function BufferReader(head, tail) {
        var _this = _super.call(this) || this;
        _this.subject = new rxjs_1.Subject();
        _this.buffer = Buffer.from('');
        _this.head = Buffer.from(head);
        _this.tail = Buffer.from(tail);
        return _this;
    }
    BufferReader.prototype.extract = function () {
        var head_idx = this.buffer.indexOf(this.head);
        var tail_idx = this.buffer.indexOf(this.tail);
        var data = this.buffer.slice(head_idx + this.head.length, tail_idx);
        this.buffer = this.buffer.slice(tail_idx + this.tail.length);
        return data;
    };
    BufferReader.prototype._write = function (chunk, encoding, callback) {
        this.buffer = Buffer.concat([this.buffer, chunk]);
        while (this.buffer.includes(this.tail)) {
            var extracted = this.extract();
            this.subject.next(extracted.toString('utf8'));
        }
        callback();
    };
    return BufferReader;
}(stream_1.Writable));
function write(stream, string) {
    return new rxjs_1.Observable(function (sub) {
        var success = stream.write(Buffer.from(string));
        if (success) {
            sub.complete();
        }
        else {
            stream.once('drain', function () { return sub.complete(); });
        }
    });
}
var PowerShell = /** @class */ (function () {
    function PowerShell() {
        this.success$ = new rxjs_1.Subject();
        this.error$ = new rxjs_1.Subject();
        this.warning$ = new rxjs_1.Subject();
        this.verbose$ = new rxjs_1.Subject();
        this.debug$ = new rxjs_1.Subject();
        this.info$ = new rxjs_1.Subject();
        this.delimit_head = 'F0ZU7Wm1p4';
        this.delimit_tail = 'AdBmCXEdsB';
        this.queue = [];
        this.ready$ = new rxjs_1.BehaviorSubject(false);
        this.queued$ = new rxjs_1.Subject();
        this.initPowerShell();
        this.initReaders();
        this.initQueue();
        this.ready$.next(true);
    }
    PowerShell.prototype.initPowerShell = function () {
        var args = ['-NoLogo', '-NoExit', '-Command', '-'];
        var exe = os_1.default.platform() === 'win32' ? 'powershell' : 'pwsh';
        this.powershell = child_process_1.spawn(exe, args, { stdio: 'pipe' });
        if (!this.powershell.pid) {
            throw new Error('could not start child process');
        }
        this.powershell.once('error', function () {
            throw new Error('child process threw an error');
        });
        this.powershell.stdin.setDefaultEncoding('utf8');
        this.powershell.stdout.setEncoding('utf8');
        this.powershell.stderr.setEncoding('utf8');
        this.stdin = this.powershell.stdin;
        this.stdout = this.powershell.stdout;
        this.stderr = this.powershell.stderr;
    };
    PowerShell.prototype.initReaders = function () {
        var _this = this;
        this.read_out = new BufferReader(this.delimit_head, this.delimit_tail);
        this.read_err = new BufferReader(this.delimit_head, this.delimit_tail);
        this.stdout.pipe(this.read_out);
        this.stderr.pipe(this.read_err);
        this.read_err.subject.subscribe(function (res) {
            _this.error$.next([res]);
        });
    };
    PowerShell.prototype.initQueue = function () {
        var _this = this;
        rxjs_1.combineLatest([this.queued$, this.ready$])
            .subscribe(function (_a) {
            var _ = _a[0], ready = _a[1];
            if (ready && _this.queue.length > 0) {
                var next_1 = _this.queue.shift();
                log.info('Running: %O', next_1.command);
                _this._call(next_1.wrapped).subscribe(function (res) {
                    next_1.subject.next(res);
                    next_1.subject.complete();
                }, function (err) {
                    next_1.subject.error(err);
                });
            }
        });
    };
    PowerShell.prototype._call = function (wrapped) {
        var _this = this;
        this.ready$.next(false);
        write(this.stdin, wrapped).subscribe();
        return this.read_out.subject.pipe(operators_1.take(1), operators_1.map(function (res) {
            var result = JSON.parse(res).result;
            var success = parseStream(result.success, result.format);
            var error = parseStream(result.error, 'json');
            var warning = parseStream(result.warning, 'json');
            var verbose = parseStream(result.verbose, 'string');
            var debug = parseStream(result.debug, 'string');
            var info = parseStream(result.info, 'json');
            if (success.length > 0)
                _this.success$.next(success);
            if (error.length > 0)
                _this.error$.next(error);
            if (warning.length > 0)
                _this.warning$.next(warning);
            if (verbose.length > 0)
                _this.verbose$.next(verbose);
            if (debug.length > 0)
                _this.debug$.next(debug);
            if (info.length > 0)
                _this.info$.next(info);
            var streams = {
                success: success,
                error: error,
                warning: warning,
                verbose: verbose,
                debug: debug,
                info: info,
            };
            return streams;
        }), operators_1.finalize(function () { return _this.ready$.next(true); }));
    };
    PowerShell.prototype.call = function (command, format) {
        if (format === void 0) { format = 'json'; }
        var subject = new SubjectWithPromise();
        var wrapped = wrapper_1.wrap(command, this.delimit_head, this.delimit_tail, format);
        var queued = {
            command: command,
            wrapped: wrapped,
            subject: subject,
        };
        this.queue.push(queued);
        this.queued$.next(queued);
        return subject;
    };
    PowerShell.prototype.destroy = function () {
        return this.powershell.kill();
    };
    return PowerShell;
}());
exports.PowerShell = PowerShell;
