"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.wrap = void 0;
var os_1 = __importDefault(require("os"));
function serialise(variable, format) {
    if (format === 'json') {
        return "ConvertTo-Json -InputObject @(" + variable + ") -Compress";
    }
    if (format === 'string') {
        return "ConvertTo-Json -InputObject @(" + variable + " | ForEach-Object { Out-String -InputObject $_ }) -Compress";
    }
    else {
        return "" + variable;
    }
}
function wrap(command, delimit_head, delimit_tail, format) {
    var template = "\n    $OutputEncoding = [Console]::OutputEncoding = [Text.UTF8Encoding]::UTF8;\n    $vv = \"fps_verbose.tmp\"\n    $dv = \"fps_debug.tmp\"\n    $delimit_head_A = \"" + delimit_head.slice(0, 5) + "\"\n    $delimit_head_B = \"" + delimit_head.slice(5) + "\"\n    $delimit_tail_A = \"" + delimit_tail.slice(0, 5) + "\"\n    $delimit_tail_B = \"" + delimit_tail.slice(5) + "\"\n    try {\n        Invoke-Command -NoNewScope -ScriptBlock {\n            " + command + "\n        } 1>$null 2>$null 3>$null 4>$vv 5>$dv 6>$null -ov ov -ev ev -wv wv -iv iv\n    } \n    catch { }\n    finally {\n\n        $verbose = Get-Content $vv\n        $debug = Get-Content $dv\n\n        $rxjs_pwsh = [pscustomobject]@{ \n            result = [pscustomobject]@{ \n                success = " + serialise('$ov', format) + "\n                error = " + serialise('$ev', 'string') + "\n                warning = " + serialise('$wv', 'string') + "\n                verbose = " + serialise('$verbose', 'string') + "\n                debug = " + serialise('$debug', 'string') + "\n                info = " + serialise('$iv', 'string') + "\n                format = \"" + format + "\"\n            }\n        }\n        $rxjs_pwsh_json = $rxjs_pwsh | ConvertTo-Json -Depth 2\n        \"$delimit_head_A$delimit_head_B\" + $rxjs_pwsh_json + \"$delimit_tail_A$delimit_tail_B\"\n    }\n    " + os_1.default.EOL + "\n    ";
    return template;
}
exports.wrap = wrap;
